function func1()
{
    console("func1")
}



/**range [0,1) */
function urandom()
{return Math.random()}
/**uniform distribution [-scale,scale)*/
function uni(scale=1)
{return (urandom()-0.5)*2*scale}
/** 
 * @template T
 * @param {T[]} arr
 * @returns {T}
 * */
function choose(arr=[])
{
    if (Array.isArray(arr))
    {
        return arr[parseInt(urandom()*arr.length)]
    }
    return arr
}
/** 
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 * */
function argmin(arr=[],key=parseInt)
{
    var k=arr.map(x=>key(x)).map(x=>isNaN(x)?Infinity:x)
    var kmin=Math.min(...(k.flat()))
    return k.findIndex(x=>x==kmin)
}
/**
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 */
function min(arr=[],key=parseInt,_default=undefined)
{
    if (arr.length==0 && _default!==undefined)return _default
    return arr[argmin(arr,key)]
}

/**
 * @param {Number[]} arr
 */
function sum(arr=[])
{return arr.map(x=>isNaN(x)?0:x).flat().reduce((a,b)=>(a+b))}


/**
 * @template T
 * @param {T[]} arr1
 * @param {T[]} arr2
 * @param {(a:T,b:T)=>Number} key
 * @returns {T[][]}
 */
function pair(arr1=[],arr2=[],key=(a,b)=>Math.abs(a-b))
{
    var arr1=Array.from(arr1).reverse()
    var arr2=Array.from(arr2)
    var out=[]
    while (arr1.length>0 && arr2.length>0)
    {
        var a=arr1.pop()
        var bi=argmin(arr2,(b)=>key(a,b))
        var b=arr2.splice(bi,1)[0]
        out.push([a,b])
    }
    return out
}



function goodCount(name="")
{
    if (name=="")return countDroid(DROID_ANY,me)/getDroidLimit(me)

    if (!isStructureAvailable(name))return 1
    var base=getStructureLimit(name,me)
    if (name=="A0ResourceExtractor")base=getStructureLimit("A0PowerGenerator",me)*4
    if (base==0)return 1    
    return enumStruct(me,name).length/base
}






/** 
 * @param {_object} a
 * @param {_object} b
*/
function byBorn(a,b)
{return (a.born+a.id/10000000)-(b.born+b.id/10000000)}

function isSpecial(droid)
{
    if (droid.name=="Laser4-PlasmaCannon")return true
    //if (droid.name.includes("Flame") || droid.name.includes("Thermite"))return true
    return false
}
function isDamaged(droid)
{
    return goodCount("A0RepairCentre3")>0 && droid.health<50//goodCount("A0RepairCentre3")>0 && droid.health<(50*(1.8-goodCount()))
}
function isFree(droid)
{
    if (droid===undefined)return false
    return !isDamaged(droid) && droid.order!=DORDER_RECYCLE && droid.order!=DORDER_RTR
}
function isJammed(droid)
{return enumRange(droid.x,droid.y,2).filter(x=>x.type==DROID).length>3}

function distBetween(object,object2)
{
    if (object===undefined || object2===undefined)return Infinity
    return distBetweenTwoPoints(object.x,object.y,object2.x,object2.y)
}
/** for sorting */
function distTo(object)
{return (object2)=>distBetween(object,object2)}

function enumOil()
{return enumFeature(ALL_PLAYERS).filter((x)=>(x.stattype === OIL_RESOURCE))}
/** 
 * @returns {String[]}
*/
function enumStat(x=Stats.Building)
{return Object.keys(x).map(i=>x[i].Id)}

function enumEnemy()
{
    return startPositions.map((x,i)=>i).filter(i=>!allianceExistsBetween(me,i))
}

/** build as a larger building will preserve more space */
function spamBuild(truck,struct="A0PowerGenerator",near,as,spread=0,safe=true)
{
    if (near===undefined)near=truck
    if (as===undefined)as=struct
    var pos=pickStructLocation(truck,as,near.x+uni(spread),near.y+uni(spread))
    if (struct=="A0ResourceExtractor")pos=near
    if (pos===undefined)return
    if (safe && !safeDest(me,pos.x,pos.y))return
    return orderDroidBuild(truck, DORDER_BUILD, struct, pos.x,pos.y)
}

function spamMove(droid,scale=5,near,order=DORDER_MOVE,range=Infinity)
{
    if (near===undefined)near=droid
    if (range!==Infinity)
    {
        var d=Math.hypot(near.x-droid.x,near.y-droid.y)
        var coef=range/d
        if (d>range)near={"x":droid.x+(near.x-droid.x)*coef,"y":droid.y+(near.y-droid.y)*coef}
    }
    if (droid.name=="Laser4-PlasmaCannon" || droid.name.includes("Howitzer") || droid.name.includes("Mortar"))order=DORDER_PATROL
    if (!droid.name.startsWith("Cyb"))order=DORDER_PATROL
    try{orderDroidLoc(droid,order,near.x+Math.round(uni(scale)),near.y+Math.round(uni(scale)))}
    catch{}
}



