const _core=[
    "A0CommandCentre","A0PowerGenerator","A0ResearchFacility",
    "A0LightFactory","A0VTolFactory1","A0CyborgFactory",
    "A0RepairCentre3","A0VtolPad",
    "A0Sat-linkCentre","A0LasSatCommand"]
const _coreMod={
    "Research Facility":["A0ResearchModule1",1],
    "Power Generator":["A0PowMod1",1],
    "Factory":["A0FacMod1",2],
    "VTOL Factory":["A0FacMod1",2],
}
const _defense=["X-Super-MassDriver","X-Super-Cannon","Emplacement-Rail3","Emplacement-Rail2","AASite-QuadBof02","AASite-QuadBof","Tower-Projector","PillBox5","A0HardcreteMk1Wall"]
const _defenseAA=["WallTower-SamHvy","P0-AASite-Laser","P0-AASite-SAM1","AASite-QuadBof02","P0-AASite-Sunburst","AASite-QuadMg1","AASite-QuadBof"]
const _sensor=["Sys-SensoTowerWS","Sys-SensoTower02","A0HardcreteMk1Wall"]
const _artillery=["Emplacement-HvART-pit","Emplacement-Howitzer150","Emplacement-Howitzer105","Emplacement-MortarPit02","Emplacement-MortarPit01","A0HardcreteMk1Wall"]


function goodCore(name="")
{
    var x=goodCount(name)
    if (name=="A0CommandCentre")return 0.7
    if (name=="A0ResearchFacility")return x*0.8-.2
    if (name=="A0LightFactory")return x-.21
    if (name=="A0CyborgFactory")return x-.3
    if (name=="A0VtolPad")return 0.6
    if (name=="A0PowerGenerator")return x-.6+playerPower(me)/2500
    return x
}

function dumbTruck()
{
    var droidTeam=enumDroid(me)//.filter(x=>urandom(x.id+gameTime)<0.2)
    var tobuildTeam=enumStruct(me).filter(x=>x.status==BEING_BUILT).filter(x=>x.stattype!=OIL_RESOURCE)
    var tomodTeam=enumStruct(me).filter(x=>_coreMod[x.name]!=undefined).filter(x=>isStructureAvailable(_coreMod[x.name][0],me) && x.modules<_coreMod[x.name][1])
    var truckTeam=droidTeam.filter(droid=>droid.droidType==DROID_CONSTRUCT).filter(truck=>truck.order!=DORDER_BUILD).sort(byBorn)
    var truckTeam2=truckTeam.splice(0,parseInt(truckTeam.length/3))
    
    var truckLock={}
    if (goodCount("A0ResourceExtractor")<goodCount("A0PowerGenerator"))
    {
        var tos=pair(truckTeam2,enumOil(),distBetween)
        tos.forEach((x)=>{
            var [truck,oil]=x
            spamBuild(truck,"A0ResourceExtractor",oil)
        })
    }

    truckTeam.forEach((truck)=>{
        if (tobuildTeam.length>0)
        {
            var nearestTobuild=min(tobuildTeam,distTo(truck))
            if (distBetween(truck,nearestTobuild)<8)return orderDroidObj(truck,DORDER_HELPBUILD,nearestTobuild)
        }

        var core=min(_core.filter((x)=>isStructureAvailable(x,me)),goodCore)
        if (!!core && !truckLock[core])
        {
            truckLock[core]=true
            if (core!="A0VtolPad" || enumDroid(me).filter(isVTOL).length>(enumStruct(me,"A0VtolPad").length*2))
            return spamBuild(truck,core,min(enumStruct(me,core),x=>x.born))
        }

        if (tomodTeam.length>0)
        {
            var nearestTomod=min(tomodTeam,distTo(truck))
            if (distBetween(truck,nearestTomod)<32)return orderDroidBuild(truck,DORDER_BUILD,_coreMod[nearestTomod.name][0],nearestTomod.x,nearestTomod.y)
        }

        if (playerPower(me)>1500)
        {
            var defense=_defense.find(x=>isStructureAvailable(x,me))
            var sensor=_sensor.find(x=>isStructureAvailable(x,me))  
            var artillery=_artillery.find(x=>isStructureAvailable(x,me))   
            var AA=_defenseAA.find(x=>isStructureAvailable(x,me))   
            var auxr=defense
            var as="A0RepairCentre3"//"A0LightFactory"
            if (auxr.startsWith("X-Super-"))as="A0LightFactory"

            if (urandom()<0.4+auxr.startsWith("X-Super-")*.4)
            {
                auxr=artillery
                as="A0PowerGenerator"
                if (urandom()<0.2){auxr=sensor}
            }
            
            if (urandom()<0.3 && NeedAA)
            {
                auxr=AA
                as="A0RepairCentre3"
            }

            if (!!auxr && !truckLock[auxr])
            {
                truckLock[auxr]=true
                spamBuild(truck,auxr,truck,as,5)
            }
        }
    })

}

setTimer(dumbTruck.name, 809+me*3);