/** Test toward a direction until value change */
function testRange(func=(x,y)=>safeDest(me,x,y),x,y,dx,dy)
{
    var z0=func(x,y)
    var d0=Math.hypot(dx,dy)
    var d1=0
    var [ux,uy]=[dx/d0,dy/d0]
    while (1)
    {
        try
        {
            var z1=func(x+ux,y+uy)
            d1+=1
            if (z1!=z0)break
            if (d1>=d0)break
        }
        catch
        {
            break
        }
    }
    return Math.hypot(ux,uy)
}

function pos(x=0,y=0)
{
    return {"x":x,"y":y}
}
function posSub(a={"x":0,"y":0},b={"x":0,"y":0})
{
   return pos(a.x-b.x,a.y-b.y)
}
function posMix(coef=1,a={"x":0,"y":0},b={"x":0,"y":0})
{
    return pos(a.x*coef+b.x*(1-coef), a.y*coef+b.y*(1-coef))
}
function posSum(...a)
{
    var [x,y]=[0,0]
    a.forEach(i=>{
        x+=i.x
        y+=i.y
    })
    return pos(x,y)
}
function posStd(...a)
{
    var u=posMix(1/a.length,posSum(...a))
    var [x,y]=[0,0]
    a.forEach(i=>{
        x+=Math.abs(i.x-u.x)
        y+=Math.abs(i.y-u.y)
    })
    return posMix(1/a.length,pos(x,y))
}
function posLen(a={"x":0,"y":0})
{
    return Math.hypot(a.x,a.y)
}
function posMul(a={"x":0,"y":0}, b={"x":1,"y":0})
{
    return pos(a.x*b.x,a.y*b.y)
}


function posNorm(a={"x":0,"y":0}, b={"x":1,"y":0})
{
    var rad=Math.atan2(b.y-a.y,b.x-a.x)
    var rad2=rad+Math.PI/2
    return pos(Math.cos(rad2), Math.sin(rad2))
}
function posUnify(a={"x":0,"y":0})
{
    var d=Math.hypot(a.x,a.y)
    return pos(a.x/d,a.y/d)
}