var _research=class {
  constructor() {
      this.power=0,
      this.points=0,
      this.started=false,
      this.done=false,
      this.name="HEAT Cannon Shells",
      this.id="R-Wpn-Cannon-Damage01",
      this.type=0
}}
var research0=new _research()

var _object=class {
  constructor() {
      this.type=0,
      this.id=0,
      this.x=0,
      this.y=0,
      this.z=0,
      this.player=0,
      this.selected=false,
      this.name="object",
      this.health=100,
      this.armour=1,
      this.thermal=1,
      this.born=0
}}
var object0=new _object()

class _droid extends _object {
  constructor() {
      super()
      this.order=0,
      this.action=0,
      this.droidType=0,
      this.group=null,
      this.armed=undefined, //for VTOL, deprecated
      this.experience=0,
      this.cost=255,
      this.isVTOL=false,
      this.canHitAir=false,
      this.canHitGround=true,
      this.isSensor=false,
      this.isCB=false,
      this.isRadarDetector=false,
      this.hasIndirect=false,
      this.range=1024,
      this.body="Body11ABT",
      this.bodySize=2,
      this.propulsion="HalfTrack",
      this.weapons=[{"name":"Cannon2A-TMk1","fullname":"Medium Cannon","id":"Cannon2A-TMk1","lastFired":0,"armed":100}]
  }
}
var droid0=new _droid() 

class _struct extends _object {
  constructor() {
      super()
      this.status=0,
      this.cost=1,
      this.stattype=0,
      this.modules=0,
      this.canHitAir=false,
      this.canHitGround=false,
      this.isSensor=false,
      this.isCB=false,
      this.isRadarDetector=false,
      this.range=8,
      this.hasIndirect=false,
      this.weapons=[{"name":"Cannon2A-TMk1","fullname":"Medium Cannon","id":"Cannon2A-TMk1","lastFired":0,"armed":100}]
  }
}
var struct0=new _struct() 

const ALL_PLAYERS=0
const ALLIES=0
const ENEMIES=0

/**.**/
const ARTIFACT='ARTIFACT'

/**and*/
const BEING_BUILT='BEING_BUILT'

/**.**/
const BUILT='BUILT'

/**.**/
const COMMAND_CONTROL='COMMAND_CONTROL'

/**,*/
const CYBORG_FACTORY='CYBORG_FACTORY'

/**,*/
const DEFENSE='DEFENSE'

/**Order a droid to attack something.  **/
const DORDER_ATTACK='DORDER_ATTACK'

/**Order a droid to build something.  **/
const DORDER_BUILD='DORDER_BUILD'

/**Assign the droid to a commander. (3.2+ only)  **/
const DORDER_COMMANDERSUPPORT='DORDER_COMMANDERSUPPORT'

/**Order a droid to demolish something.  **/
const DORDER_DEMOLISH='DORDER_DEMOLISH'

/**Order a transport to disembark its units at the given position.  **/
const DORDER_DISEMBARK='DORDER_DISEMBARK'

/**Order a droid to embark on a transport.  **/
const DORDER_EMBARK='DORDER_EMBARK'

/**Order a droid to fire at whatever the target sensor is targeting. (3.2+ only)  **/
const DORDER_FIRESUPPORT='DORDER_FIRESUPPORT'

/**Order a droid to help build something.  **/
const DORDER_HELPBUILD='DORDER_HELPBUILD'

/**Order a droid to hold its position. (3.2+ only)  **/
const DORDER_HOLD='DORDER_HOLD'

/**Order a droid to build something repeatedly in a line.  **/
const DORDER_LINEBUILD='DORDER_LINEBUILD'

/**Order a droid to move somewhere.  **/
const DORDER_MOVE='DORDER_MOVE'

/**Order a droid to keep a target in sensor view. (3.2+ only)  **/
const DORDER_OBSERVE='DORDER_OBSERVE'

/**Order a droid to patrol.  **/
const DORDER_PATROL='DORDER_PATROL'

/**Order a VTOL droid to rearm. If given a target, will go to specified rearm pad. If not, will go to nearest rearm pad. (3.2+ only)  **/
const DORDER_REARM='DORDER_REARM'

/**Order a droid to pick up something. (3.2+ only)  **/
const DORDER_RECOVER='DORDER_RECOVER'

/**Order a droid to factory for recycling. (3.2+ only)**/
const DORDER_RECYCLE='DORDER_RECYCLE'

/**Order a droid to repair something.  **/
const DORDER_REPAIR='DORDER_REPAIR'

/**Order a droid to return to base. (3.2+ only)  **/
const DORDER_RTB='DORDER_RTB'

/**Order a droid to return for repairs. (3.2+ only)  **/
const DORDER_RTR='DORDER_RTR'

/**Order a droid to move somewhere and stop to attack anything on the way.  **/
const DORDER_SCOUT='DORDER_SCOUT'

/**Order a droid to stop whatever it is doing. (3.2+ only)  **/
const DORDER_STOP='DORDER_STOP'

/**,*/
const DROID='DROID'

/**Commanders.**/
const DROID_COMMAND='DROID_COMMAND'

/**Trucks and cyborg constructors.  **/
const DROID_CONSTRUCT='DROID_CONSTRUCT'

/**Cyborgs with weapons.  **/
const DROID_CYBORG='DROID_CYBORG'

/**Unit with ECM jammer turret.  **/
const DROID_ECM='DROID_ECM'

/**Non-cyborg two-legged units, like scavengers.  **/
const DROID_PERSON='DROID_PERSON'

/**Units with repair turret, including repair cyborgs.  **/
const DROID_REPAIR='DROID_REPAIR'

/**Units with sensor turret.  **/
const DROID_SENSOR='DROID_SENSOR'

/**Droid transporter.  **/
const DROID_SUPERTRANSPORTER='DROID_SUPERTRANSPORTER'

/**Cyborg transporter.  **/
const DROID_TRANSPORTER='DROID_TRANSPORTER'

/**Droids with weapon turrets, except cyborgs.  **/
const DROID_WEAPON='DROID_WEAPON'

/**,*/
const FACTORY='FACTORY'

/**.**/
const FEATURE='FEATURE'

/**and*/
const GATE='GATE'

/**,*/
const HQ='HQ'

/**,*/
const LASSAT='LASSAT'

/**and*/
const OIL_DRUM='OIL_DRUM'

/**,*/
const OIL_RESOURCE='OIL_RESOURCE'

/**or*/
const POWER_GEN='POWER_GEN'

/**,*/
const REARM_PAD='REARM_PAD'

/**,*/
const REPAIR_FACILITY='REPAIR_FACILITY'

/**.*/
const RESEARCH_DATA='RESEARCH_DATA'

/**,*/
const RESEARCH_LAB='RESEARCH_LAB'

/**,*/
const RESOURCE_EXTRACTOR='RESOURCE_EXTRACTOR'

/**,*/
const SAT_UPLINK='SAT_UPLINK'

/**or*/
const STRUCTURE='STRUCTURE'

/**,*/
const VTOL_FACTORY='VTOL_FACTORY'

/**,*/
const WALL='WALL'

/** Mark string for translation. 
* @param {String} string
*/
function _(string) {}

/** Activate a special ability on a structure. Currently only works on the lassat.
The lassat needs a target. 
* @param {_struct} structure
* @param {_object} target
*/
function activateStructure(structure, target) {}

/** Send a beacon message to target player. Target may also be ```ALLIES```.
Message is currently unused. Returns a boolean that is true on success. (3.2+ only) 
* @param {Number} x
* @param {Number} y
* @param {Number} playerFilter
* @param {String} message
*/
function addBeacon(x, y, playerFilter, message) {return true}

/** Create and place a droid at the given x, y position as belonging to the given player, built with
the given components. Currently does not support placing droids in multiplayer, doing so will
cause a desync. Returns the created droid on success, otherwise returns null. Passing "" for
reserved parameters is recommended. In 3.2+ only, to create droids in off-world (campaign mission list),
pass -1 as both x and y. 
* @param {Number} player
* @param {Number} x
* @param {Number} y
* @param {String} templateName
* @param {String[]|String} body
* @param {String[]|String} propulsion
* @param {""} reserved
* @param {""} reserved
* @param {(String[]|String)[]} turrets
*/
function addDroid(player, x, y, templateName, body, propulsion, reserved, reserved, ...turrets) {}

/** Load a droid, which is currently located on the campaign off-world mission list,
into a transporter, which is also currently on the campaign off-world mission list.
(3.2+ only) 
* @param {_droid} transporter
* @param {_droid} droid
*/
function addDroidToTransporter(transporter, droid) {}

/** Create and place a feature at the given x, y position. Will cause a desync in multiplayer.
Returns the created game object on success, null otherwise. (3.2+ only) 
* @param {String} featureName
* @param {Number} x
* @param {Number} y
*/
function addFeature(featureName, x, y) {}

/** Add a label to a game object. If there already is a label by that name, it is overwritten.
This is a fast operation of O(log n) algorithmic complexity. (3.2+ only)
Can optionally specify an initial "triggered" value for the label. (3.4+ only) 
* @param {_object} object
* @param {String} label
* @param {} triggered
*/
function addLabel(object, label, triggered) {}

/** Add an invisible viewer at a given position for given player that shows map in given range. ```radar```
is false for vision reveal, or true for radar reveal. The difference is that a radar reveal can be obstructed
by ECM jammers. ```expiry```, if non-zero, is the game time at which the spotter shall automatically be
removed. The function returns a unique ID that can be used to remove the spotter with ```removeSpotter```. (3.2+ only) 
* @param {Number} x
* @param {Number} y
* @param {Number} player
* @param {Number} range
* @param {Number} radar
* @param {Number} expiry
*/
function addSpotter(x, y, player, range, radar, expiry) {}

/** Create a structure on the given position. Returns the structure on success, null otherwise.
Position uses world coordinates, if you want use position based on Map Tiles, then
use as addStructure(structureName, players, x*128, y*128) 
* @param {String} structureName
* @param {Number} player
* @param {Number} x
* @param {Number} y
*/
function addStructure(structureName, player, x, y) {}

/** Returns true if an alliance exists between the two players, or they are the same player. 
* @param {Number} player1
* @param {Number} player2
*/
function allianceExistsBetween(player1, player2) {return true}

/** Mix user set limits with script set limits and defaults. 
*/
function applyLimitSet() {}

/** Perform automatic save 
*/
function autoSave() {}

/** Start factory production of new droid with the given name, body, propulsion and turrets.
The reserved parameter should be passed **null** for now. The components can be
passed as ordinary strings, or as a list of strings. If passed as a list, the first available
component in the list will be used. The second reserved parameter used to be a droid type.
It is now unused and in 3.2+ should be passed "", while in 3.1 it should be the
droid type to be built. Returns a boolean that is true if production was started. 
* @param {_struct} factory
* @param {String} templateName
* @param {String[]|String} body
* @param {String[]|String} propulsion
* @param {""} reserved
* @param {""} reserved
* @param {(String[]|String)[]} turrets
*/
function buildDroid(factory, templateName, body, propulsion, reserved, reserved, ...turrets) {return true}

/** Slide the camera over to the given position on the map. (3.2+ only) 
* @param {Number} x
* @param {Number} y
*/
function cameraSlide(x, y) {}

/** Make the camera follow the given droid object around. Pass in a null object to stop. (3.2+ only) 
* @param {_droid} droid
*/
function cameraTrack(droid) {}

/** Slide the camera to the given zoom distance. Normal camera zoom ranges between 500 and 5000. (3.2+ only) 
* @param {} viewDistance
* @param {Number} speed
*/
function cameraZoom(viewDistance, speed) {}

/** Center the player's camera at the given position. 
* @param {Number} x
* @param {Number} y
*/
function centreView(x, y) {}

/** Change a player's colour slot. The current player colour can be read from the ```playerData``` array. There are as many
colour slots as the maximum number of players. (3.2.3+ only) 
* @param {Number} player
* @param {Number} colour
*/
function changePlayerColour(player, colour) {}

/** Send a message to playerFilter. playerFilter may also be ```ALL_PLAYERS``` or ```ALLIES```.
Returns a boolean that is true on success. (3.2+ only) 
* @param {Number} playerFilter
* @param {String} message
*/
function chat(playerFilter, message) {return true}

/** Clear the console. (3.3+ only) 
*/
function clearConsole() {}

/** Finish all researches for the given player. 
* @param {Number} player
*/
function completeAllResearch(player) {}

/** Finish a research for the given player.
forceResearch will allow a research topic to be researched again. 3.3+ 
* @param {String} researchName
* @param {Number} player
* @param {} forceResearch
*/
function completeResearch(researchName, player, forceResearch) {}

/** Checks whether a given component is available to the current player. The first argument is
optional and deprecated. 
* @param {Number} componentType
* @param {String} componentName
*/
function componentAvailable(componentType, componentName) {return true}

/** Print text to the player console. 
* @param {(String)[]} strings
*/
function console(...strings) {}

/** Count the number of droids that a given player has. Droid type must be either
```DROID_ANY```, ```DROID_COMMAND``` or ```DROID_CONSTRUCT```.
The playerFilter parameter can be a specific player, ```ALL_PLAYERS```, ```ALLIES``` or ```ENEMIES```. 
* @param {Number} droidType
* @param {Number} playerFilter
*/
function countDroid(droidType, playerFilter) {return 0}

/** Count the number of structures of a given type.
The playerFilter parameter can be a specific player, ```ALL_PLAYERS```, ```ALLIES``` or ```ENEMIES```. 
* @param {String} structureName
* @param {Number} playerFilter
*/
function countStruct(structureName, playerFilter) {return 0}

/** Output text to the command line. 
* @param {(String)[]} string
*/
function debug(...string) {}

/** Returns the function name of the caller of the current context as a string (if available).
ex.
```js
function funcA() {
const callerFuncName = debugGetCallerFuncName();
debug(callerFuncName);
}
function funcB() {
funcA();
}
funcB();
```
Will output: "funcB"
Useful for debug logging. 
*/
function debugGetCallerFuncName() {}

/** Return distance between two points. 
* @param {Number} x1
* @param {Number} y1
* @param {Number} x2
* @param {Number} y2
*/
function distBetweenTwoPoints(x1, y1, x2, y2) {return 0}

/** Donate a game object (restricted to droids before 3.2.3) to another player. Returns true if
donation was successful. May return false if this donation would push the receiving player
over unit limits. (3.2+ only) 
* @param {_object} object
* @param {Number} player
*/
function donateObject(object, player) {return true}

/** Donate power to another player. Returns true. (3.2+ only) 
* @param {Number} amount
* @param {Number} player
*/
function donatePower(amount, player) {return true}

/** Return whether or not the given droid could possibly drive to the given position. Does
not take player built blockades into account. 
* @param {_droid} droid
* @param {Number} x
* @param {Number} y
*/
function droidCanReach(droid, x, y) {return true}

/** Output text to a debug file. (3.2+ only) 
* @param {(String)[]} string
*/
function dump(...string) {}

/** The given component is made available for research for the given player. 
* @param {String} componentName
* @param {Number} player
*/
function enableComponent(componentName, player) {}

/** Enable a research for the given player, allowing it to be researched. 
* @param {String} researchName
* @param {Number} player
*/
function enableResearch(researchName, player) {}

/** The given structure type is made available to the given player. It will appear in the
player's build list. 
* @param {String} structureName
* @param {Number} player
*/
function enableStructure(structureName, player) {}

/** Enable a specific template (even if design is disabled). 
* @param {String} templateName
*/
function enableTemplate(templateName) {}

/** Returns an array of game objects seen within the given area that passes the optional filter
which can be one of a player index, ```ALL_PLAYERS```, ```ALLIES``` or ```ENEMIES```. By default, filter is
```ALL_PLAYERS```. Finally an optional parameter can specify whether only visible objects should be
returned; by default only visible objects are returned. The label can either be actual
positions or a label to an AREA. Calling this function is much faster than iterating over all
game objects using other enum functions. (3.2+ only) 
* @param {Number} x1
* @param {Number} y1
* @param {Number} x2
* @param {Number} y2
* @param {String} label
* @param {Number} playerFilter
* @param {Boolean} seen
*/
function enumArea(x1, y1, x2, y2 = label, playerFilter, seen) {return [object0]}

/** Return an array containing all the non-transient radar blips that the given player
can see. This includes sensors revealed by radar detectors, as well as ECM jammers.
It does not include units going out of view. 
* @param {Number} player
*/
function enumBlips(player) {return [object0]}

/** Returns an array of droid objects inside given transport. (3.2+ only) 
* @param {_droid} transporterDroid
*/
function enumCargo(transporterDroid) {return [droid0]}

/** Returns an array of droid objects. If no parameters given, it will
return all of the droids for the current player. The second, optional parameter
is the name of the droid type. The third parameter can be used to filter by
visibility - the default is not to filter. 
* @param {Number} player
* @param {Number} droidType
* @param {Number} playerFilter
*/
function enumDroid(player, droidType, playerFilter) {return [droid0]}

/** Returns an array of all features seen by player of given name, as defined in "features.json".
If player is ```ALL_PLAYERS```, it will return all features irrespective of visibility to any player. If
name is empty, it will return any feature. 
* @param {Number} playerFilter
* @param {String} featureName
*/
function enumFeature(playerFilter, featureName) {return [object0]}

/** Return an array containing all the gateways on the current map. The array contains object with the properties
x1, y1, x2 and y2. (3.2+ only) 
*/
function enumGateways() {return [object0]}

/** Return an array containing all the members of a given group. 
* @param {Number} groupId
*/
function enumGroup(groupId) {return [object0]}

/** Returns a string list of labels that exist for this map. The optional filter
parameter can be used to only return labels of one specific type. (3.2+ only) 
* @param {Number} filterLabelType
*/
function enumLabels(filterLabelType) {return ''}

/** Returns an array of game objects seen within range of given position that passes the optional playerFilter
which can be one of a player index, ```ALL_PLAYERS```, ```ALLIES``` or ```ENEMIES```. By default, playerFilter is
```ALL_PLAYERS```. Finally an optional parameter can specify whether only visible objects should be
returned; by default only visible objects are returned. Calling this function is much faster than
iterating over all game objects using other enum functions. (3.2+ only) 
* @param {Number} x
* @param {Number} y
* @param {Number} range
* @param {Number} playerFilter
* @param {Boolean} seen
*/
function enumRange(x, y, range, playerFilter, seen) {return [object0]}

/** Returns an array of all research objects that are currently and immediately available for research. 
*/
function enumResearch() {return [research0]}

/** Return an array containing all game objects currently selected by the host player. (3.2+ only) 
*/
function enumSelected() {return [object0]}

/** Returns an array of structure objects. If no parameters given, it will
return all of the structures for the current player. The second parameter
can be either a string with the name of the structure type as defined in
"structures.json", or a stattype as defined in ```Structure```. The
third parameter can be used to filter by visibility, the default is not
to filter. 
* @param {Number} player
* @param {Number} structureType
* @param {Number} playerFilter
*/
function enumStruct(player, structureType, playerFilter) {return [struct0]}

/** Returns an array of structure objects in your base when on an off-world mission, NULL otherwise.
If no parameters given, it will return all of the structures for the current player.
The second parameter can be either a string with the name of the structure type as defined
in "structures.json", or a stattype as defined in ```Structure```.
The third parameter can be used to filter by visibility, the default is not
to filter. 
* @param {Number} player
* @param {Number} structureType
* @param {Number} playerFilter
*/
function enumStructOffWorld(player, structureType, playerFilter) {return [struct0]}

/** Return an array containing all the buildable templates for the given player. (3.2+ only) 
* @param {Number} player
*/
function enumTemplates(player) {return [object0]}

/** An event that is called whenever an alliance is accepted. 
* @param {Number} from
* @param {Number} to
*/
function eventAllianceAccepted(from, to) {}

/** An event that is called whenever an alliance is broken. 
* @param {Number} from
* @param {Number} to
*/
function eventAllianceBroken(from, to) {}

/** An event that is called whenever an alliance offer is requested. 
* @param {Number} from
* @param {Number} to
*/
function eventAllianceOffer(from, to) {}

/** An event that is run whenever a droid enters an area label. The area is then
deactived. Call resetArea() to reactivate it. The name of the event is
`eventArea${label}`. 
* @param {_droid} droid
*/
function eventArealabel(droid) {}

/** An event that is run when an object belonging to the script's controlling player is
attacked. The attacker parameter may be either a structure or a droid. 
* @param {_object} victim
* @param {_object} attacker
*/
function eventAttacked(victim, attacker) {}

/** An event that is run whenever a beacon message is received. The ```from``` parameter is the
player sending the beacon. For the moment, the ```to``` parameter is always the script player.
Message may be undefined. 
* @param {Number} x
* @param {Number} y
* @param {Number} from
* @param {Number} to
* @param {String} message
*/
function eventBeacon(x, y, from, to, message) {}

/** An event that is run whenever a beacon message is removed. The ```from``` parameter is the
player sending the beacon. For the moment, the ```to``` parameter is always the script player. 
* @param {Number} from
* @param {Number} to
*/
function eventBeaconRemoved(from, to) {}

/** An event that is run whenever a chat message is received. The ```from``` parameter is the
player sending the chat message. For the moment, the ```to``` parameter is always the script
player. 
* @param {Number} from
* @param {Number} to
* @param {String} message
*/
function eventChat(from, to, message) {}

/** Game entered or left cheat/debug mode.
The entered parameter is true if cheat mode entered, false otherwise. 
* @param {Boolean} entered
*/
function eventCheatMode(entered) {}

/** An event that is run after the current player has moved a delivery point. 
*/
function eventDeliveryPointMoved() {}

/** An event that is run when the current player starts to move a delivery point. 
*/
function eventDeliveryPointMoving() {}

/** An event that is run when current user picks a body in the design menu. 
*/
function eventDesignBody() {}

/** An event that is run when current user picks a command turret in the design menu. 
*/
function eventDesignCommand() {}

/** An event that is run whenever a new droid template is created. It is only
run on the client of the player designing the template. 
* @param {} template
*/
function eventDesignCreated(template) {}

/** An event that is run when current user picks a propulsion in the design menu. 
*/
function eventDesignPropulsion() {}

/** An event that is run when current user leaves the design menu. 
*/
function eventDesignQuit() {}

/** An event that is run when current user picks a system other than command turret in the design menu. 
*/
function eventDesignSystem() {}

/** An event that is run when current user picks a weapon in the design menu. 
*/
function eventDesignWeapon() {}

/** An event that is run whenever an object is destroyed. Careful passing
the parameter object around, since it is about to vanish! 
* @param {_object} object
*/
function eventDestroyed(object) {}

/** An event that is run every time a droid is built. The structure parameter is set
if the droid was produced in a factory. It is not triggered for droid theft or
gift (check ```eventObjectTransfer``` for that). 
* @param {_droid} droid
* @param {_struct} structure
*/
function eventDroidBuilt(droid, structure) {}

/** A droid should be given new orders. 
* @param {_droid} droid
*/
function eventDroidIdle(droid) {}

/** An event that is run once as the game is initialized. Not all game state may have been
properly initialized by this time, so use this only to initialize script state. 
*/
function eventGameInit() {}

/** An event that is run when game is loaded from a saved game. There is usually no need to use this event. 
*/
function eventGameLoaded() {}

/** An event that is run after game is saved. There is usually no need to use this event. 
*/
function eventGameSaved() {}

/** An event that is run before game is saved. There is usually no need to use this event. 
*/
function eventGameSaving() {}

/** An event that is run whenever a group becomes empty. Input parameter
is the about to be killed object, the group's id, and the new group size. 
* @param {_object} gameObject
* @param {Number} groupId
* @param {} newSize
*/
function eventGroupLoss(gameObject, groupId, newSize) {}

/** An event that is run sometimes when a member of a group, which was marked by a group label,
which was reset through resetLabel() to subscribe for events, goes from not seen to seen.
First parameter is **game object** doing the seeing, the next the id of the group
being seen. 
* @param {Number} viewer
* @param {Number} group
*/
function eventGroupSeen(viewer, group) {}

/** An event that is called whenever user presses a key in the game, not counting chat
or other pop-up user interfaces. The key values are currently undocumented. 
* @param {} meta
* @param {} key
*/
function eventKeyPressed(meta, key) {}

/** An event that is run when current user opens the build menu. 
*/
function eventMenuBuild() {}

/** An event that is run when current user picks something new in the build menu. 
*/
function eventMenuBuildSelected() {}

/** An event that is run when current user opens the manufacture menu. 
*/
function eventMenuManufacture() {}

/** An event that is run when current user opens the research menu. 
*/
function eventMenuResearch() {}

/** An event that is run when current user picks something new in the research menu. 
*/
function eventMenuResearchSelected() {}

/** An event that is run when the mission timer has run out. 
*/
function eventMissionTimeout() {}

/** An event that is run when an object (ex. droid, structure) is recycled. 
*/
function eventObjectRecycled() {}

/** An event that is run sometimes when an object, which was marked by an object label,
which was reset through resetLabel() to subscribe for events, goes from not seen to seen.
An event that is run sometimes when an objectm  goes from not seen to seen.
First parameter is **game object** doing the seeing, the next the game
object being seen. 
* @param {Number} viewer
* @param {Boolean} seen
*/
function eventObjectSeen(viewer, seen) {}

/** An event that is run whenever an object is transferred between players,
for example due to a Nexus Link weapon. The event is called after the
object has been transferred, so the target player is in object.player.
The event is called for both players. 
* @param {_object} object
* @param {Number} from
*/
function eventObjectTransfer(object, from) {}

/** An event that is run whenever a feature is picked up. It is called for
all players / scripts.
Careful passing the parameter object around, since it is about to vanish! (3.2+ only) 
* @param {} feature
* @param {_droid} droid
*/
function eventPickup(feature, droid) {}

/** An event that is run after a player has left the game. 
* @param {Number} player
*/
function eventPlayerLeft(player) {}

/** An event that is run whenever a new research is available. The structure
parameter is set if the research comes from a research lab owned by the
current player. If an ally does the research, the structure parameter will
be set to null. The player parameter gives the player it is called for. 
* @param {Number} research
* @param {_struct} structure
* @param {Number} player
*/
function eventResearched(research, structure, player) {}

/** An event that is triggered whenever the host player selects one or more game objects.
The ```objects``` parameter contains an array of the currently selected game objects.
Keep in mind that the player may drag and drop select many units at once, select one
unit specifically, or even add more selections to a current selection one at a time.
This event will trigger once for each user action, not once for each selected or
deselected object. If all selected game objects are deselected, ```objects``` will
be empty. 
* @param {_object[]} objects
*/
function eventSelectionChanged(objects) {}

/** An event that is run once the game has started and all game data has been loaded. 
*/
function eventStartLevel() {}

/** An event that is run every time a structure is produced. The droid parameter is set
if the structure was built by a droid. It is not triggered for building theft
(check ```eventObjectTransfer``` for that). 
* @param {_struct} structure
* @param {_droid} droid
*/
function eventStructureBuilt(structure, droid) {}

/** An event that is run every time a structure begins to be demolished. This does
not trigger again if the structure is partially demolished. 
* @param {_struct} structure
* @param {_droid} droid
*/
function eventStructureDemolish(structure, droid) {}

/** An event that is run every time a structure is ready to perform some
special ability. It will only fire once, so if the time is not right,
register your own timer to keep checking. 
* @param {_struct} structure
*/
function eventStructureReady(structure) {}

/** An event that is run every time a structure starts to be upgraded. 
* @param {_struct} structure
*/
function eventStructureUpgradeStarted(structure) {}

/** An event that is called from a script and synchronized with all other scripts and hosts
to prevent desync from happening. Sync requests must be carefully validated to prevent
cheating! 
* @param {Number} req_id
* @param {Number} x
* @param {Number} y
* @param {Number} obj_id
* @param {Number} obj_id2
*/
function eventSyncRequest(req_id, x, y, obj_id, obj_id2) {}

/** An event that is run when the mission transporter has arrived at the map edge with reinforcements. 
* @param {_droid} transport
*/
function eventTransporterArrived(transport) {}

/** An event that is run when the mission transporter has no more reinforcements to deliver. 
* @param {_droid} transport
*/
function eventTransporterDone(transport) {}

/** An event that is run when the mission transporter has left the map. 
* @param {_droid} transport
*/
function eventTransporterExit(transport) {}

/** An event that is run when the mission transporter has landed with reinforcements. 
* @param {_droid} transport
*/
function eventTransporterLanded(transport) {}

/** An event that is run when the mission transporter has been ordered to fly off. 
* @param {_droid} transport
*/
function eventTransporterLaunch(transport) {}

/** An event that is run when a video show stopped playing. 
*/
function eventVideoDone() {}

/** Increase a player's power as if that player had power income equal to current income
over the given amount of extra time. (3.2+ only) 
* @param {Number} time
* @param {Number} player
*/
function extraPowerTime(time, player) {}

/** Return list of research items remaining to be researched for the given research item. (3.2+ only)
(Optional second argument 3.2.3+ only) 
* @param {String} researchName
* @param {Number} player
*/
function findResearch(researchName, player) {return [research0]}

/** Fires a weapon at the given coordinates (3.3+ only). The player is who owns the projectile.
Please use fireWeaponAtObj() to damage objects as multiplayer and campaign
may have different friendly fire logic for a few weapons (like the lassat). 
* @param {String} weaponName
* @param {Number} x
* @param {Number} y
* @param {Number} player
*/
function fireWeaponAtLoc(weaponName, x, y, player) {}

/** Fires a weapon at a game object (3.3+ only). The player is who owns the projectile. 
* @param {String} weaponName
* @param {_object} gameObject
* @param {Number} player
*/
function fireWeaponAtObj(weaponName, gameObject, player) {}

/** End game in victory or defeat. 
* @param {Number} gameWon
* @param {} showBackDrop
* @param {} showOutro
*/
function gameOverMessage(gameWon, showBackDrop, showOutro) {}

/** Return maximum number of droids that this player can produce. This limit is usually
fixed throughout a game and the same for all players. If no arguments are passed,
returns general droid limit for the current player. If a second, droid type argument
is passed, the limit for this droid type is returned, which may be different from
the general droid limit (eg for commanders and construction droids). (3.2+ only) 
* @param {Number} player
* @param {Number} droidType
*/
function getDroidLimit(player, droidType) {return 0}

/** Return droid in production in given factory. Note that this droid is fully
virtual, and should never be passed anywhere. (3.2+ only) 
* @param {_struct} factory
*/
function getDroidProduction(factory) {return droid0}

/** Get the percentage of experience this player droids are going to gain. (3.2+ only) 
* @param {Number} player
*/
function getExperienceModifier(player) {return 0}

/** Get a label string belonging to a game object. If the object has multiple labels, only the first
label found will be returned. If the object has no labels, undefined is returned.
This is a relatively slow operation of O(n) algorithmic complexity. (3.2+ only) 
* @param {_object} object
*/
function getLabel(object) {return 0}

/** Get time remaining on mission countdown in seconds. (3.2+ only) 
*/
function getMissionTime() {return 0}

/** Return the current mission type. (3.3+ only) 
*/
function getMissionType() {return 0}

/** Returns the current multiplayer tech level. (3.3+ only) 
*/
function getMultiTechLevel() {return 0}

/** Fetch something denoted by a label, a map position or its object ID. A label refers to an area,
a position or a **game object** on the map defined using the map editor and stored
together with the map. In this case, the only argument is a text label. The function
returns an object that has a type variable defining what it is (in case this is
unclear). This type will be one of DROID, STRUCTURE, FEATURE, AREA, GROUP or POSITION.
The AREA has defined 'x', 'y', 'x2', and 'y2', while POSITION has only defined 'x' and 'y'.
The GROUP type has defined 'type' and 'id' of the group, which can be passed to enumGroup().
This is a fast operation of O(log n) algorithmic complexity. If the label is not found, an
undefined value is returned. If whatever object the label should point at no longer exists,
a null value is returned. 
* @param {String} label
* @param {Number} x
* @param {Number} y
* @param {Number} type
* @param {Number} player
* @param {Number} id
*/
function getObject(label = x, y = type, player, id) {return object0}

/** Fetch information about a given technology item, given by a string that matches
its definition in "research.json". If not found, returns null. 
* @param {String} researchName
* @param {Number} player
*/
function getResearch(researchName, player) {return research0}

/** Return the current fog reveal status. (3.3+ only) 
*/
function getRevealStatus() {return 0}

/** Get the limits of the scrollable area of the map as an area object. (3.2+ only) 
*/
function getScrollLimits() {return 0}

/** Returns build limits for a structure. 
* @param {String} structureName
* @param {Number} player
*/
function getStructureLimit(structureName, player) {return 0}

/** Return information about a particular weapon type. DEPRECATED - query the Stats object instead. (3.2+ only) 
* @param {String} weaponName
*/
function getWeaponInfo(weaponName) {return 0}

/** Add given game object to the given group. 
* @param {Number} groupId
* @param {_object} object
*/
function groupAdd(groupId, object) {}

/** Add any droids inside the given area to the given group. (3.2+ only) 
* @param {Number} groupId
* @param {Number} x1
* @param {Number} y1
* @param {Number} x2
* @param {Number} y2
*/
function groupAddArea(groupId, x1, y1, x2, y2) {}

/** Add given droid to given group. Deprecated since 3.2 - use groupAdd() instead. 
* @param {Number} groupId
* @param {_droid} droid
*/
function groupAddDroid(groupId, droid) {}

/** Return the number of droids currently in the given group. Note that you can use groupSizes[] instead. 
* @param {Number} groupId
*/
function groupSize(groupId) {return 0}

/** See wzscript docs for info, to the extent any exist. (3.2+ only) 
* @param {String} message
* @param {Number} messageType
* @param {Number} player
* @param {} immediate
*/
function hackAddMessage(message, messageType, player, immediate) {}

/** Function to perform unit testing. It will throw a script error and a game assert. (3.2+ only) 
* @param {} condition
* @param {(String)[]} message
*/
function hackAssert(condition, ...message) {}

/** Do not save the given global given by name to savegames. Must be
done again each time game is loaded, since this too is not saved. 
* @param {String} name
*/
function hackDoNotSave(name) {}

/** Function to find and return a game object of ```DROID```, ```FEATURE``` or ```STRUCTURE``` types, if it exists.
Otherwise, it will return null. This function is DEPRECATED by getObject(). (3.2+ only) 
* @param {Number} objectType
* @param {Number} player
* @param {Number} id
*/
function hackGetObj(objectType, player, id) {}

/** Mark the given tile(s) on the map. Either give a ```POSITION``` or ```AREA``` label,
or a tile x, y position, or four positions for a square area. If no parameter
is given, all marked tiles are cleared. (3.2+ only) 
* @param {String} label
* @param {Number} x
* @param {Number} y
* @param {Number} x2
* @param {Number} y2
*/
function hackMarkTiles(label = x, y, x2, y2) {}

/** Turn off network transmissions. FIXME - find a better way. 
*/
function hackNetOff() {}

/** Turn on network transmissions. FIXME - find a better way. 
*/
function hackNetOn() {}

/** (3.3+ only) 
*/
function hackPlayIngameAudio() {}

/** See wzscript docs for info, to the extent any exist. (3.2+ only) 
* @param {String} message
* @param {Number} messageType
* @param {Number} player
*/
function hackRemoveMessage(message, messageType, player) {}

/** Stop the in-game music. (3.3+ only)
This should be called from the eventStartLevel() event (or later).
Currently only used from the tutorial. 
*/
function hackStopIngameAudio() {}

/** Hide user interface. (3.2+ only) 
*/
function hideInterface() {}

/** Includes another source code file at this point. You should generally only specify the filename,
not try to specify its path, here.
However, *if* you specify sub-paths / sub-folders, the path separator should **always** be forward-slash ("/"). 
* @param {String} filePath
*/
function include(filePath) {}

/** Reads a JSON file and returns an object. You should generally only specify the filename,
However, *if* you specify sub-paths / sub-folders, the path separator should **always** be forward-slash ("/"). 
* @param {String} filePath
*/
function includeJSON(filePath) {}

/** Returns whether a particular player is a spectator. (4.2+ only)
Can pass -1 as player to get the spectator status of the client running the script. (Useful for the "rules" scripts.) 
* @param {Number} player
*/
function isSpectator(player) {return true}

/** Returns true if given structure can be built. It checks both research and unit limits. 
* @param {String} structureName
* @param {Number} player
*/
function isStructureAvailable(structureName, player) {return true}

/** Returns true if given droid is a VTOL (not including transports). 
* @param {_droid} droid
*/
function isVTOL(droid) {return true}

/** Load the level with the given name. 
* @param {String} levelName
*/
function loadLevel(levelName) {}

/** The given component is made available to the given player. This means the player can
actually build designs with it. 
* @param {String} componentName
* @param {Number} player
*/
function makeComponentAvailable(componentName, player) {}

/** Create a template (virtual droid) with the given components. Can be useful for calculating the cost
of droids before putting them into production, for instance. Will fail and return null if template
could not possibly be built using current research. (3.2+ only) 
* @param {Number} player
* @param {String} templateName
* @param {String[]|String} body
* @param {String[]|String} propulsion
* @param {""} reserved
* @param {(String[]|String)[]} turrets
*/
function makeTemplate(player, templateName, body, propulsion, reserved, ...turrets) {}

/** Registers a new event namespace. All events can now have this prefix. This is useful for
code libraries, to implement event that do not conflict with events in main code. This
function should be called from global; do not (for hopefully obvious reasons) put it
inside an event. 
* @param {String} prefix
*/
function namespace(prefix) {}

/** Allocate a new group. Returns its numerical ID. Deprecated since 3.2 - you should now
use your own number scheme for groups. 
*/
function newGroup() {return 0}

/** Give a droid an order to do something. (3.2+ only) 
* @param {_droid} droid
* @param {Number} order
*/
function orderDroid(droid, order) {}

/** Give a droid an order to build something at the given position. Returns true if allowed. 
* @param {_droid} droid
* @param {Number} order
* @param {String} structureName
* @param {Number} x
* @param {Number} y
* @param {Number} direction
*/
function orderDroidBuild(droid, order, structureName, x, y, direction) {return true}

/** Give a droid an order to do something at the given location. 
* @param {_droid} droid
* @param {Number} order
* @param {Number} x
* @param {Number} y
*/
function orderDroidLoc(droid, order, x, y) {}

/** Give a droid an order to do something to something. 
* @param {_droid} droid
* @param {Number} order
* @param {_object} object
*/
function orderDroidObj(droid, order, object) {}

/** Pick a location for constructing a certain type of building near some given position.
Returns an object containing "type" ```POSITION```, and "x" and "y" values, if successful. 
* @param {_droid} droid
* @param {String} structureName
* @param {Number} x
* @param {Number} y
* @param {} maxBlockingTiles
*/
function pickStructLocation(droid, structureName, x, y, maxBlockingTiles) {return object0}

/** Play a sound, optionally at a location. 
* @param {String} sound
* @param {Number} x
* @param {Number} y
* @param {Number} z
*/
function playSound(sound, x, y, z) {}

/** Return amount of power held by the given player. 
* @param {Number} player
*/
function playerPower(player) {return 0}

/** Calls a function with given arguments, measures time it took to evaluate the function,
and adds this time to performance monitor statistics. Transparently returns the
function's return value. The function to run is the first parameter, and it
_must be quoted_. (3.2+ only) 
* @param {String} functionName
* @param {} arguments
*/
function profile(functionName, arguments) {}

/** Return true if a droid with a given propulsion is able to travel from (x1, y1) to (x2, y2).
Does not take player built blockades into account. (3.2+ only) 
* @param {String} propulsionName
* @param {Number} x1
* @param {Number} y1
* @param {Number} x2
* @param {Number} y2
*/
function propulsionCanReach(propulsionName, x1, y1, x2, y2) {return true}

/** Start researching the first available technology on the way to the given technology.
First parameter is the structure to research in, which must be a research lab. The
second parameter is the technology to pursue, as a text string as defined in "research.json".
The second parameter may also be an array of such strings. The first technology that has
not yet been researched in that list will be pursued. 
* @param {_struct} labStructure
* @param {Number} research
*/
function pursueResearch(labStructure, research) {}

/** Queues up a function to run at a later game frame. This is useful to prevent
stuttering during the game, which can happen if too much script processing is
done at once.  The function to run is the first parameter, and it
_must be quoted_, otherwise the function will be inlined.
The second parameter is the delay in milliseconds, if it is omitted or 0,
the function will be run at a later frame.  A third optional
parameter can be a **game object** to pass to the queued function. If the **game object**
dies before the queued call runs, nothing happens. 
* @param {String} functionName
* @param {Number} milliseconds
* @param {_object} object
*/
function queue(functionName, milliseconds, object) {}

/** Return amount of power queued up for production by the given player. (3.2+ only) 
* @param {Number} player
*/
function queuedPower(player) {return 0}

/** Make the current script receive all events, even those not meant for 'me'. (3.2+ only) 
* @param {Boolean} enabled
*/
function receiveAllEvents(enabled) {}

/** Remove a beacon message sent to playerFilter. Target may also be ```ALLIES```.
Returns a boolean that is true on success. (3.2+ only) 
* @param {Number} playerFilter
*/
function removeBeacon(playerFilter) {return true}

/** Remove a beacon message sent to target player. Target may also be ```ALLIES```.
Returns a boolean that is true on success. (3.2+ only) 
* @param {Number} playerFilter
*/
function removeBeacon(playerFilter) {return true}

/** Remove a label from the game. Returns the number of labels removed, which should normally be
either 1 (label found) or 0 (label not found). (3.2+ only) 
* @param {String} label
*/
function removeLabel(label) {return 0}

/** Remove the given game object with special effects. Returns a boolean that is true on success.
A second, optional boolean parameter specifies whether special effects are to be applied. (3.2+ only) 
* @param {_object} gameObject
* @param {} sfx
*/
function removeObject(gameObject, sfx) {return true}

/** Remove reticule button. DO NOT USE FOR ANYTHING. 
* @param {Number} buttonId
*/
function removeReticuleButton(buttonId) {}

/** Remove a spotter given its unique ID. (3.2+ only) 
* @param {Number} spotterId
*/
function removeSpotter(spotterId) {}

/** Immediately remove the given structure from the map. Returns a boolean that is true on success.
No special effects are applied. DEPRECATED since 3.2. Use `removeObject` instead. 
* @param {_struct} structure
*/
function removeStruct(structure) {return true}

/** Remove a template. 
* @param {String} templateName
*/
function removeTemplate(templateName) {}

/** Removes an existing timer. The first parameter is the function timer to remove,
and its name _must be quoted_. 
* @param {String} functionName
*/
function removeTimer(functionName) {}

/** Replace one texture with another. This can be used to for example give buildings on a specific tileset different
looks, or to add variety to the looks of droids in campaign missions. (3.2+ only) 
* @param {String} oldFilename
* @param {String} newFilename
*/
function replaceTexture(oldFilename, newFilename) {}

/** Reset the trigger on an area. Next time a unit enters the area, it will trigger
an area event. Optionally add a filter on it in the second parameter, which can
be a specific player to watch for, or ```ALL_PLAYERS``` by default.
This is a fast operation of O(log n) algorithmic complexity. DEPRECATED - use resetLabel instead. (3.2+ only) 
* @param {String} labelName
* @param {Number} playerFilter
*/
function resetArea(labelName, playerFilter) {}

/** Reset the trigger on an label. Next time a unit enters the area, it will trigger
an area event. Next time an object or a group is seen, it will trigger a seen event.
Optionally add a filter on it in the second parameter, which can
be a specific player to watch for, or ```ALL_PLAYERS``` by default.
This is a fast operation of O(log n) algorithmic complexity. (3.2+ only) 
* @param {String} labelName
* @param {Number} playerFilter
*/
function resetLabel(labelName, playerFilter) {}

/** Swap mission type and bring back units previously stored at the start
of the mission (see cam3-c mission). (3.3+ only). 
*/
function restoreLimboMissionData() {}

/** Returns true if given player is safe from hostile fire at the given location, to
the best of that player's map knowledge. Does not work in campaign at the moment. 
* @param {Number} player
* @param {Number} x
* @param {Number} y
*/
function safeDest(player, x, y) {return true}

/** Send an alliance request to a player. (3.3+ only) 
* @param {Number} player
*/
function sendAllianceRequest(player) {}

/** Set alliance status between two players to either true or false. (3.2+ only) 
* @param {Number} player1
* @param {Number} player2
* @param {} areAllies
*/
function setAlliance(player1, player2, areAllies) {}

/** Set the assembly point droids go to when built for the specified structure. (3.2+ only) 
* @param {_struct} structure
* @param {Number} x
* @param {Number} y
*/
function setAssemblyPoint(structure, x, y) {}

/** Set the campaign number. (3.3+ only) 
* @param {Number} campaignNumber
*/
function setCampaignNumber(campaignNumber) {}

/** Set the maximum number of commanders that this player can produce.
THIS FUNCTION IS DEPRECATED AND WILL BE REMOVED! (3.2+ only) 
* @param {Number} player
* @param {Number} maxNumber
*/
function setCommanderLimit(player, maxNumber) {}

/** Set the maximum number of constructors that this player can produce.
THIS FUNCTION IS DEPRECATED AND WILL BE REMOVED! (3.2+ only) 
* @param {Number} player
* @param {Number} maxNumber
*/
function setConstructorLimit(player, maxNumber) {}

/** Whether to allow player to design stuff. 
* @param {Number} allowDesignValue
*/
function setDesign(allowDesignValue) {}

/** Set the amount of experience a droid has. Experience is read using floating point precision. 
* @param {_droid} droid
* @param {Number} experience
*/
function setDroidExperience(droid, experience) {}

/** Set the maximum number of droids that this player can produce. If a third
parameter is added, this is the droid type to limit. It can be ```DROID_ANY```
for droids in general, ```DROID_CONSTRUCT``` for constructors, or ```DROID_COMMAND```
for commanders. (3.2+ only) 
* @param {Number} player
* @param {Number} maxNumber
* @param {Number} droidType
*/
function setDroidLimit(player, maxNumber, droidType) {}

/** Set the percentage of experience this player droids are going to gain. (3.2+ only) 
* @param {Number} player
* @param {} percent
*/
function setExperienceModifier(player, percent) {}

/** Set the colour of the fog (4.2.5+ only) 
* @param {Number} r
* @param {Number} g
* @param {Number} b
*/
function setFogColour(r, g, b) {}

/** Change the health of the given game object, in percentage. Does not take care of network sync, so for multiplayer games,
needs wrapping in a syncRequest. (3.2.3+ only.) 
* @param {_object} object
* @param {Number} health
*/
function setHealth(object, health) {}

/** Turns visible minimap on or off in the GUI. 
* @param {} visible
*/
function setMiniMap(visible) {}

/** Set mission countdown in seconds. 
* @param {Number} time
*/
function setMissionTime(time) {}

/** Creates an area on the map on which nothing can be built. If playerFilter is zero,
then landing lights are placed. If playerFilter is ```ALL_PLAYERS```, then a limbo landing zone
is created and limbo droids placed. 
* @param {Number} x1
* @param {Number} y1
* @param {Number} x2
* @param {Number} y2
* @param {Number} playerFilter
*/
function setNoGoArea(x1, y1, x2, y2, playerFilter) {}

/** Set or unset an object flag on a given game object. Does not take care of network sync, so for multiplayer games,
needs wrapping in a syncRequest. (3.3+ only.)
Recognized object flags: ```OBJECT_FLAG_UNSELECTABLE``` - makes object unavailable for selection from player UI. 
* @param {_object} object
* @param {Number} flag
* @param {Number} flagValue
*/
function setObjectFlag(object, flag, flagValue) {}

/** Set a player's power directly. (Do not use this in an AI script.) 
* @param {Number} power
* @param {Number} player
*/
function setPower(power, player) {}

/** Set a player's power modifier percentage. (Do not use this in an AI script.) (3.2+ only) 
* @param {Number} powerModifier
* @param {Number} player
*/
function setPowerModifier(powerModifier, player) {}

/** Set a player's power storage maximum. (Do not use this in an AI script.) (3.2+ only) 
* @param {Number} powerMaximum
* @param {Number} player
*/
function setPowerStorageMaximum(powerMaximum, player) {}

/** Set time for reinforcements to arrive. If time is negative, the reinforcement GUI
is removed and the timer stopped. Time is in seconds.
If time equals to the magic ```LZ_COMPROMISED_TIME``` constant, reinforcement GUI ticker
is set to "--:--" and reinforcements are suppressed until this function is called
again with a regular time value. 
* @param {Number} time
*/
function setReinforcementTime(time) {}

/** Add reticule button. buttonId is which button to change, where zero is zero is the middle button, then going clockwise from
the uppermost button. filename is button graphics and filenameDown is for highlighting. The tooltip is the text you see when
you mouse over the button. Finally, the callback is which scripting function to call. Hide and show the user interface
for such changes to take effect. (3.2+ only) 
* @param {Number} buttonId
* @param {} tooltip
* @param {String} filename
* @param {String} filenameDown
* @param {} callback
*/
function setReticuleButton(buttonId, tooltip, filename, filenameDown, callback) {}

/** Set reticule flash on or off. (3.2.3+ only) 
* @param {Number} buttonId
* @param {} flash
*/
function setReticuleFlash(buttonId, flash) {}

/** Set the fog reveal status. (3.3+ only) 
* @param {Boolean} status
*/
function setRevealStatus(status) {}

/** Limit the scrollable area of the map to the given rectangle. (3.2+ only) 
* @param {Number} x1
* @param {Number} y1
* @param {Number} x2
* @param {Number} y2
*/
function setScrollLimits(x1, y1, x2, y2) {}

/** Change the skybox. (3.2+ only) 
* @param {String} textureFilename
* @param {Number} windSpeed
* @param {Number} scale
*/
function setSky(textureFilename, windSpeed, scale) {}

/** Set build limits for a structure. 
* @param {String} structureName
* @param {Number} limit
* @param {Number} player
*/
function setStructureLimits(structureName, limit, player) {}

/** Set the ambient, diffuse and specular colour intensities of the Sun lighting source. (3.2+ only) 
* @param {Number} ambient_r
* @param {Number} ambient_g
* @param {Number} ambient_b
* @param {Number} diffuse_r
* @param {Number} diffuse_g
* @param {Number} diffuse_b
* @param {Number} specular_r
* @param {Number} specular_g
* @param {Number} specular_b
*/
function setSunIntensity(ambient_r, ambient_g, ambient_b, diffuse_r, diffuse_g, diffuse_b, specular_r, specular_g, specular_b) {}

/** Move the position of the Sun, which in turn moves where shadows are cast. (3.2+ only) 
* @param {Number} x
* @param {Number} y
* @param {Number} z
*/
function setSunPosition(x, y, z) {}

/** Set a function to run repeated at some given time interval. The function to run
is the first parameter, and it _must be quoted_, otherwise the function will
be inlined. The second parameter is the interval, in milliseconds. A third, optional
parameter can be a **game object** to pass to the timer function. If the **game object**
dies, the timer stops running. The minimum number of milliseconds is 100, but such
fast timers are strongly discouraged as they may deteriorate the game performance. 
* @param {String} functionName
* @param {Number} milliseconds
* @param {_object} object
*/
function setTimer(functionName, milliseconds, object) {}

/** Set the exit position for the mission transporter. (3.2+ only) 
* @param {Number} x
* @param {Number} y
* @param {Number} player
*/
function setTransporterExit(x, y, player) {}

/** Sets a number of restrictions appropriate for tutorial if set to true. 
* @param {Boolean} enableTutorialMode
*/
function setTutorialMode(enableTutorialMode) {}

/** Set the current weather. This should be one of ```WEATHER_RAIN```, ```WEATHER_SNOW``` or ```WEATHER_CLEAR```. (3.2+ only) 
* @param {Number} weatherType
*/
function setWeather(weatherType) {}

/** Show user interface. (3.2+ only) 
*/
function showInterface() {}

/** Open the reticule menu widget. (3.3+ only) 
* @param {Number} buttonId
*/
function showReticuleWidget(buttonId) {}

/** Set the entry position for the mission transporter, and make it start flying in
reinforcements. If you want the camera to follow it in, use cameraTrack() on it.
The transport needs to be set up with the mission droids, and the first transport
found will be used. (3.2+ only) 
* @param {Number} x
* @param {Number} y
* @param {Number} player
*/
function startTransporterEntry(x, y, player) {}

/** Is given structure idle? 
* @param {_struct} structure
*/
function structureIdle(structure) {}

/** Generate a synchronized random number in range 0...(limit - 1) that will be the same if this function is
run on all network peers in the same game frame. If it is called on just one peer (such as would be
the case for AIs, for instance), then game sync will break. (3.2+ only) 
* @param {Number} limit
*/
function syncRandom(limit) {}

/** Generate a synchronized event request that is sent over the network to all clients and executed simultaneously.
Must be caught in an eventSyncRequest() function. All sync requests must be validated when received, and always
take care only to define sync requests that can be validated against cheating. (3.2+ only) 
* @param {Number} req_id
* @param {Number} x
* @param {Number} y
* @param {_object} object
* @param {_object} object2
*/
function syncRequest(req_id, x, y, object, object2) {}

/** Returns tile type of a given map tile, such as ```TER_WATER``` for water tiles or ```TER_CLIFFFACE``` for cliffs.
Tile types regulate which units may pass through this tile. (3.2+ only) 
* @param {Number} x
* @param {Number} y
*/
function terrainType(x, y) {}

/** Returns whether the given map tile is burning. (3.5+ only) 
* @param {Number} x
* @param {Number} y
*/
function tileIsBurning(x, y) {return true}

/** Transform a player to a spectator. (4.2+ only)
This is a one-time transformation, destroys the player's HQ and all of their remaining units, and must occur deterministically on all clients. 
* @param {Number} player
*/
function transformPlayerToSpectator(player) {}

/** Change if the mission transporter will fetch droids in non offworld missions
setReinforcementTime() is be used to hide it before coming back after the set time
which is handled by the campaign library in the victory data section (3.3+ only). 
* @param {Number} flag
*/
function useSafetyTransport(flag) {}

/**A sparse, read-only array containing rules information for game entity types.

(For now only the highest level member attributes are documented here. Use the 'jsdebug' cheat

to see them all.)

These values are defined:

* ```Body``` Droid bodies

* ```Sensor``` Sensor turrets

* ```ECM``` ECM (Electronic Counter-Measure) turrets

* ```Propulsion``` Propulsions

* ```Repair``` Repair turrets (not used, incidentally, for repair centers)

* ```Construct``` Constructor turrets (eg for trucks)

* ```Brain``` Brains

* ```Weapon``` Weapon turrets

* ```WeaponClass``` Defined weapon classes

* ```Building``` Buildings*/
const Stats={
"Body":[{"Id":""}],
"Sensor":[{"Id":""}],
"ECM":[{"Id":""}],
"Propulsion":[{"Id":""}],
"Repair":[{"Id":""}],
"Construct":[{"Id":""}],
"Brain":[{"Id":""}],
"Weapon":[{"Id":""}],
"WeaponClass":[""],
"Building":[{"Id":""}]
}

/**A special array containing per-player rules information for game entity types,

which can be written to in order to implement upgrades and other dynamic rules changes. Each item in the

array contains a subset of the sparse array of rules information in the ```Stats``` global.

These values are defined:

* ```Body``` Droid bodies

* ```Sensor``` Sensor turrets

* ```Propulsion``` Propulsions

* ```ECM``` ECM (Electronic Counter-Measure) turrets

* ```Repair``` Repair turrets (not used, incidentally, for repair centers)

* ```Construct``` Constructor turrets (eg for trucks)

* ```Brain``` Brains

BaseCommandLimit: How many droids a commander can command. CommandLimitByLevel: How many extra droids

a commander can command for each of its rank levels. RankThresholds: An array describing how many

kills are required for this brain to level up to the next rank. To alter this from scripts, you must

set the entire array at once. Setting each item in the array will not work at the moment.

* ```Weapon``` Weapon turrets

* ```Building``` Buildings*/
const Upgrades={
"Body":[],
"Sensor":[],
"Propulsion":[],
"ECM":[],
"Repair":[],
"Construct":[],
"Brain":[{
  "BaseCommandLimit":0,
  "CommandLimitByLevel":0,
  "RankThresholds":[0],
}],
"Weapon":[],
"Building":[]
}

/**The type of alliances permitted in this game. It will be one of ```NO_ALLIANCES```, ```ALLIANCES```, ```ALLIANCES_UNSHARED``` or ```ALLIANCES_TEAMS```.*/
const alliancesType=0

/**The type of base that the game starts with. It will be one of ```CAMP_CLEAN```, ```CAMP_BASE``` or ```CAMP_WALLS```.*/
const baseType=0

/**If the current game is a challenge. (4.1.4+ only)*/
const challenge=true

/**A set of derrick starting positions on the current map. Each item in the set is an

object containing the x and y variables for a derrick.*/
const derrickPositions=[object0]

/**The currently set campaign difficulty, or the current AI's difficulty setting. It will be one of

```SUPEREASY``` (campaign only), ```EASY```, ```MEDIUM```, ```HARD``` or ```INSANE```.*/
const difficulty=0

/**The current game time. Updated before every invokation of a script.*/
const gameTime=0

/**A sparse array of group sizes. If a group has never been used, the entry in this array will

be undefined.*/
const groupSizes=[0]

/**The amount of game time without active play before a player should be considered "inactive". (0 = disable activity alerts / AFK check) (4.2.0+ only)*/
const idleTime=0

/**If the current game is a online multiplayer game or not. (3.2+ only)*/
const isMultiplayer=true

/**Height of map in tiles.*/
const mapHeight=0

/**The name of the current map.*/
const mapName='mapName'

/**Width of map in tiles.*/
const mapWidth=0

/**The number of active players in this game.*/
const maxPlayers=0

/**The player the script is currently running as.*/
const me=0

/**The current loaded mods.*/
const modList=[]

/**An array of information about the players in a game. Each item in the array is an object

containing the following variables:

* ```difficulty``` (see ```difficulty``` global constant)

* ```colour``` number describing the colour of the player

* ```position``` number describing the position of the player in the game's setup screen

* ```isAI``` whether the player is an AI (3.2+ only)

* ```isHuman``` whether the player is human (3.2+ only)

* ```name``` the name of the player (3.2+ only)

* ```team``` the number of the team the player is part of*/
const playerData=[{
"difficulty":0,
"colour":0,
"position":0,
"isAI":true,
"isHuman":true,
"name":"name",
"team":0
}]

/**The power level set for this game.*/
const powerType=0

/**Index of scavenger player. (3.2+ only)*/
const scavengerPlayer=0

/**Whether or not scavengers are activated in this game, and, if so, which type.*/
const scavengers=true

/**Base name of the script that is running.*/
const scriptName='scriptName'

/**Base path of the script that is running.*/
const scriptPath='scriptPath'

/**The player controlled by the client on which the script runs.*/
const selectedPlayer=0

/**An array of player start positions on the current map. Each item in the array is an

object containing the x and y variables for a player start position.*/
const startPositions=[object0]

/**The area name of the map.*/
const tilesetType='tilesetType'

/**Current version of the game, set in *major.minor* format.*/
const version='version'

/** A two-dimensional array of static information about the map tiles in a game. Each item in MapTiles[y][x] is an object
* containing the following variables:
*/
const MapTiles=[[{
"terrainType":0,
"height":0,
"hoverContinent":true,
"limitedContinent":true
}]]
